# wxCommand Class Reference
[Document/View Framework]

`#include <wx/cmdproc.h>`

Inheritance diagram for wxCommand:
[legend]

## Detailed Description

wxCommand is a base class for modelling an application command, which is an action usually performed by selecting a menu item, pressing a toolbar button or any other means provided by the application to change the data or view.

##

Library: wxCore

Category: Document/View Framework

See also:
  wxCommand overview

## Public Member Functions
| wxCommand (bool canUndo=false, const wxString &name=wxEmptyString)
| Constructor.
virtual | ~wxCommand ()
| Destructor.
virtual bool | CanUndo () const
| Returns true if the command can be undone, false otherwise.
virtual bool | Do ()=0
| Override this member function to execute the appropriate action when called.
virtual wxString | GetName () const
| Returns the command name.
virtual bool | Undo ()=0
| Override this member function to un-execute a previous Do.

List of all members.

## Constructor & Destructor Documentation

wxCommand::wxCommand | ( | bool | canUndo = `false`,
|  | const wxString & | name = `wxEmptyString` |
| ) |  |  |

Constructor.

wxCommand is an abstract class, so you will need to derive a new class and call this constructor from your own constructor.

Parameters:

  | canUndo | Tells the command processor whether this command is undo-able. You can achieve the same functionality by overriding the CanUndo() member function (if for example the criteria for undoability is context-dependent).
  | name | Must be supplied for the command processor to display the command name in the application's edit menu.

virtual wxCommand::~wxCommand | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual bool wxCommand::CanUndo | ( |  | ) | const`[virtual]`

Returns true if the command can be undone, false otherwise.

virtual bool wxCommand::Do | ( |  | ) | `[pure virtual]`

Override this member function to execute the appropriate action when called.

Returns:
  true to indicate that the action has taken place, false otherwise. Returning false will indicate to the command processor that the action is not undoable and should not be added to the command history.

Implemented in wxRichTextCommand.

virtual wxString wxCommand::GetName | ( |  | ) | const`[virtual]`

Returns the command name.

virtual bool wxCommand::Undo | ( |  | ) | `[pure virtual]`

Override this member function to un-execute a previous Do.

How you implement this command is totally application dependent, but typical strategies include:

- Perform an inverse operation on the last modified piece of data in the document. When redone, a copy of data stored in command is pasted back or some operation reapplied. This relies on the fact that you know the ordering of Undos; the user can never Undo at an arbitrary position in the command history.
- Restore the entire document state (perhaps using document transacting). Potentially very inefficient, but possibly easier to code if the user interface and data are complex, and an "inverse execute" operation is hard to write. The docview sample uses the first method, to remove or restore segments in the drawing.

Returns:
  true to indicate that the action has taken place, false otherwise. Returning false will indicate to the command processor that the action is not redoable and no change should be made to the command history.

Implemented in wxRichTextCommand.

|  | [ top ]